unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls;

const
    LptPort  = 'LPT1';
    Com1Port = 'COM1';
    Com2Port = 'COM2';

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

procedure PFunction(mCPIcode : String);

implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
    Memo1.Lines.LoadFromFile('Form1.frx');


end;



// Receipt 15 CPI
procedure TForm1.Button1Click(Sender: TObject);
begin
    PFunction('M');
end;


// Receipt 12 CPI
procedure TForm1.Button2Click(Sender: TObject);
begin
   PFunction('P');
end;
// Receipt 8 CPI
procedure TForm1.Button3Click(Sender: TObject);
begin
   PFunction(':');
end;


procedure PFunction(mCPIcode : String);
var
 OldCaption : String ;
 LP:HFILE;
 lpBuffer:string;
 nNumberOfBytesToWrite:integer;
 lpNumberOfBytesWritten:Cardinal	;

begin


    OldCaption := Form1.Caption;


    Form1.Caption := 'PP3000 Printing...LPT1';
    //''**Printing begin.


    LP := CreateFile(
       		     PChar(LptPort),
		     GENERIC_READ+GENERIC_WRITE,
		     0,
		     nil,
		     OPEN_EXISTING,
		     FILE_ATTRIBUTE_NORMAL,
		     0);




   // ' Cash Drawer Open & Select 12CPI character
    lpBuffer:=Chr($7) + Chr($1B) + mCPIcode;
    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);

    // Font Double-Width
    lpBuffer:= Chr($E) + 'POSiFLEX PP3000' + Chr($D) + Chr($A);
    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);


    lpBuffer:= Chr($14);
    nNumberOfBytesToWrite:=strlen(pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);

    // Underline printing
    lpBuffer := Chr($1B) + Chr($2D) + '1' + 'DATE : ' + DATETOSTR(NOW()) + '  ' +
                      'TIME : ' + TIMETOSTR(NOW()) + Chr($D) + Chr($A);

    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);

    lpBuffer := Chr($1B) + Chr($2D) + '0' + Form1.Memo1.Lines.Text;
    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);


    // Font Double-Width
    lpBuffer:= Chr($E) + '-- Thank You --' + Chr($D) + Chr($A);
    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);

    lpBuffer:= Chr($14);
    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);


    // Form feed
    lpBuffer:= Chr($C);
    nNumberOfBytesToWrite:=strlen(Pchar(lpBuffer));
    WriteFile(LP,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,nil);



    CloseHandle( LP ); 	// handle to file to close

    Form1.Caption := OldCaption;


End;




end.
